/*
	2007 nî 12 goe̍h
	Chok-chiá : Lûi Bêng-Hàn luibenghan@humanistic.org
	Lō͘-iōng: Khì Wiki Commons lia̍h tô͘, pian-chò  bat-jī-khá.
*/

%{
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>

struct kha_phinn
{
	char *tong_an, *sia, *le, *tou, *toa_ji, *hoan_ho, *kiam_cha;
	int au_piah_bin, thau, boe, kiann, liah_koe, cho_koe, si_ji_bou;
	int teng_koan, e_kha, to_chhiu, chiann_chhiu;
	struct kha_phinn *koh_1_tiunn;
};

enum tek_chit
{
	BO, TONG_AN, LE, TOU, TOA_JI, HOAN_HO, AU_PIAH_BIN, THAU, BOE, 
	TENG_KOAN, E_KHA, TO_CHHIU, CHIANN_CHHIU, SI_JI_BOU, KIAM_CHA
} mia;

enum
{
	KHANG, SOU_JI, BUN_JI_LIAT
} lui_piat; 

int siat_teng = 0;
int sou_ji;
char *bun_ji_liat;
struct kha_phinn *bat_ji_kha = NULL;
int u_kui_choa = 1, teng_tann = 0;
int soat_beng_e_ui;
FILE *ki_lok;
%}

%s Kha_Phinn
%x Bun_Ji_Liat
%s Soat_Beng

%%

<INITIAL>kha-phinn	{/* bô chò tāi-chì */}
<INITIAL>\{			{
						struct kha_phinn *chiam_si;
						BEGIN(Kha_Phinn); 
						// Seⁿ sin-ê khà-phìⁿ
						chiam_si = (struct kha_phinn *)calloc(sizeof(struct kha_phinn), 1);
						chiam_si->koh_1_tiunn = bat_ji_kha;
						bat_ji_kha = chiam_si;
						mia = BO; siat_teng = 0; lui_piat = KHANG;
					}
<Kha_Phinn>\}		{ BEGIN(INITIAL); mia = BO; siat_teng = 0; lui_piat = KHANG;}
<Kha_Phinn>tong-an	{ mia = TONG_AN; }
<Kha_Phinn>le		{ mia = LE; }
<Kha_Phinn>tou		{ mia = TOU; }
<Kha_Phinn>au-piah-bin	{ mia = AU_PIAH_BIN; }
<Kha_Phinn>toa-ji	{ mia = TOA_JI; }
<Kha_Phinn>hoan-ho	{ mia = HOAN_HO; }
<Kha_Phinn>thau		{ mia = THAU; }
<Kha_Phinn>boe		{ mia = BOE; }
<Kha_Phinn>kiam-cha	{ mia = KIAM_CHA; }
<Kha_Phinn>teng-koan	{ mia = TENG_KOAN; }
<Kha_Phinn>e-kha	{ mia = E_KHA; }
<Kha_Phinn>to-chhiu	{ mia = TO_CHHIU; }
<Kha_Phinn>chiann-chhiu	{ mia = CHIANN_CHHIU; }
<Kha_Phinn>si-ji-bou	{ mia = SI_JI_BOU; }
<Kha_Phinn>=		{ 
						if (mia == BO || lui_piat != KHANG)
						{
							fprintf(stderr, "Tī tē %d chōa, kui-ê têng-tâⁿ.\n", u_kui_choa);
							teng_tann = 1;
						}
						else siat_teng = 1;
					}
<Kha_Phinn>\"		{ bun_ji_liat = NULL; BEGIN(Bun_Ji_Liat);}
<Kha_Phinn>[0-9]+	{
						sou_ji = strtol(yytext, NULL, 10);
						lui_piat = SOU_JI;
					}
<Kha_Phinn>0x[0-9a-fA-Z]+						{
						sou_ji = strtol(yytext, NULL, 16);
						lui_piat = SOU_JI;
					}
<Kha_Phinn>;		{ 	
						if (siat_teng)
						{
							switch (mia)
							{
								case TONG_AN: 
									if (lui_piat != BUN_JI_LIAT)
									{
										fprintf(stderr, "Tī tē %d chōa, tòng-àn ài siat-chò bûn-jī-lia̍t.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->tong_an = bun_ji_liat; 
									break;
								case LE: 
									if (lui_piat != BUN_JI_LIAT)
									{
										fprintf(stderr, "Tī tē %d chōa, lē ài siat-chò bûn-jī-lia̍t.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->le = bun_ji_liat;
									break;
								case TOU: 
									if (lui_piat != BUN_JI_LIAT)
									{
										fprintf(stderr, "Tī tē %d chōa, tô͘ ài siat-chò bûn-jī-lia̍t.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->tou = bun_ji_liat;
									break;
								case TOA_JI: 
									if (lui_piat != BUN_JI_LIAT)
									{
										fprintf(stderr, "Tī tē %d chōa, tōa-jī ài siat-chò bûn-jī-lia̍t.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->toa_ji = bun_ji_liat;
									break;
								case HOAN_HO: 
									if (lui_piat != BUN_JI_LIAT)
									{
										fprintf(stderr, "Tī tē %d chōa, hoan-hō ài siat-chò bûn-jī-lia̍t.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->hoan_ho = bun_ji_liat;
									break;
								case KIAM_CHA: 
									if (lui_piat != BUN_JI_LIAT)
									{
										fprintf(stderr, "Tī tē %d chōa, kiám-cha ài siat-chò bûn-jī-lia̍t.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->kiam_cha = bun_ji_liat;
									break;
								case AU_PIAH_BIN: 
									if (lui_piat != SOU_JI)
									{
										fprintf(stderr, "Tī tē %d chōa, āu-piah-bīn ê sek-chúi ài siat-chò  sò͘-jī.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->au_piah_bin = sou_ji;
									break;
								case THAU: 
									if (lui_piat != SOU_JI)
									{
										fprintf(stderr, "Tī tē %d chōa, thâu ê jī-sò͘ ài siat-chò  sò͘-jī.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->thau = sou_ji;
									break;
								case BOE: 
									if (lui_piat != SOU_JI)
									{
										fprintf(stderr, "Tī tē %d chōa, bóe ê jī-sò͘ ài siat-chò  sò͘-jī.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->boe = sou_ji;
									break;
								case TENG_KOAN: 
									if (lui_piat != SOU_JI)
									{
										fprintf(stderr, "Tī tē %d chōa, téng-koàn ê jī-sò͘ ài siat-chò  sò͘-jī.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->teng_koan = sou_ji;
									break;
								case E_KHA: 
									if (lui_piat != SOU_JI)
									{
										fprintf(stderr, "Tī tē %d chōa, ē-kha ê jī-sò͘ ài siat-chò  sò͘-jī.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->e_kha = sou_ji;
									break;
								case TO_CHHIU: 
									if (lui_piat != SOU_JI)
									{
										fprintf(stderr, "Tī tē %d chōa, tó-chhiú ê jī-sò͘ ài siat-chò  sò͘-jī.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->to_chhiu = sou_ji;
									break;
								case CHIANN_CHHIU: 
									if (lui_piat != SOU_JI)
									{
										fprintf(stderr, "Tī tē %d chōa, chiàⁿ-chhiú ê jī-sò͘ ài siat-chò  sò͘-jī.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->chiann_chhiu = sou_ji;
									break;
								case SI_JI_BOU: 
									if (lui_piat != SOU_JI)
									{
										fprintf(stderr, "Tī tē %d chōa, sī-m̄-sī jí-bó͘ ê ài siat-chò  sò͘-jī.\n", u_kui_choa);
										teng_tann = 1;
									}
									else bat_ji_kha->si_ji_bou = sou_ji;
									break;
								case BO:
									fprintf(stderr, "Tī tē %d chōa, khiàm te̍k-chit ê miâ.\n", u_kui_choa);
									teng_tann = 1;
									break;
							}
							mia = BO; siat_teng = 0; lui_piat = KHANG;
						}
						else
						{
							fprintf(stderr, "Tī tē %d chōa, khiàm 1-ê téng-hō (=).\n", u_kui_choa);
							teng_tann = 1;
						}
					}
<Bun_Ji_Liat>[^\"\n]*			{ bun_ji_liat = strdup(yytext); }
<Bun_Ji_Liat>\"		{ 
				if (bun_ji_liat == NULL) bun_ji_liat = strdup("");
				lui_piat = BUN_JI_LIAT;
				BEGIN(Kha_Phinn);
			}
<Bun_Ji_Liat>\n		{
						fprintf(stderr, "Tī tē %d chōa, bûn-jī-lia̍t m̄-thang oàⁿ-chōa.\n", u_kui_choa);
						teng_tann = 1;
						u_kui_choa ++;
					}
<INITIAL>"/*"		{
						soat_beng_e_ui = INITIAL;
						BEGIN(Soat_Beng);
					}
<Kha_Phinn>"/*"		{ 
						soat_beng_e_ui = Kha_Phinn;
						BEGIN(Soat_Beng);
					}
<Soat_Beng>[^*\n]* 	{ /* tô͘-kak */ }
<Soat_Beng>"*"+[^*/\n]* 					{ /* tô͘-kak */ }
<Soat_Beng>\n		{ u_kui_choa ++ ; }
<Soat_Beng>"*"+"/"	{ BEGIN(soat_beng_e_ui); }
\/\/[^\n]*			{/* thô͘-kak */}
[ \t]*				{/* thô͘-kak */}
\n					{u_kui_choa ++;}

%%

void liah_tou(int, int);
void senn_kha_phinn(int, int);

#define KAN_TANN_LIAH_THANG 1
#define LIAH_TOU_KAU_OE 2
#define SENN_TOU_KAU_OE 4
#define KI_LOK_TI_TONG_AN 8
#define GIMP_KAU_OE 16

int main(int argc, char ** argv)
{
	int i, chui_kong[2], liah_thang = 0;
	pid_t kiann;
	char *tong_an_mia = NULL;

	// Chhōe tòng-àn lâi tha̍k	
	while ((i = getopt(argc, argv, "t:l:")) != -1)
	{
		switch (i)
		{
			case 't': tong_an_mia = strdup(optarg); break;
			case 'l': liah_thang = strtol(optarg, NULL, 0); break;
		}
	}
	
	if (tong_an_mia == NULL)
	{
		fprintf(stderr, "Iōng-hoat: %s -t khà-phìⁿ -l lia̍h-thâng\n", argv[0]);
		exit(0);
	}
	

	// Seⁿ chúi-kóng
	i = pipe(chui_kong);
	if (i == -1)
	{
		fprintf(stderr, "Chúi-kóng bô thong.\n");
		exit(0);
	}

	// Tha̍k tòng-àn
	yyin = fopen(tong_an_mia, "r");
	if (yyin == NULL) 
	{
		fprintf(stderr, "Tòng-àn %s tha̍k-bô\n", tong_an_mia);
		exit(0);
	}
	yylex();
	if (teng_tann)
	{
		fprintf(stderr, "Ū siá têng-tâⁿ.\n");
		exit(0);
	}

	
	if (liah_thang & (LIAH_TOU_KAU_OE | SENN_TOU_KAU_OE))
	{
		if ((liah_thang & KI_LOK_TI_TONG_AN) == KI_LOK_TI_TONG_AN)
		{
			ki_lok = fopen("ki_lok", "w");
			setlinebuf(ki_lok);
		}
		else ki_lok = stdout;
	}

	kiann = fork();
	if (kiann == 0) 
	{
		// Góa sī kiaⁿ
		close(chui_kong[0]); // bô beh tha̍k
		liah_tou(chui_kong[1], liah_thang);
	}
	else
	{
		close(chui_kong[1]); // bô beh siá
		senn_kha_phinn(chui_kong[0], liah_thang);
		// Góa sī lāu-bú
		wait(&i);
	}

	return 0;	
}


void liah_tou(int chui_kong, int liah_thang)
{
	struct kha_phinn *ki = bat_ji_kha;
	FILE *sia = fdopen(chui_kong, "w");
	FILE *thak;
	char chiam_si[1024];
	struct stat tong_an;
	int sng = 0, i, kiann;
	
	setbuf(sia, NULL); //bô beh ēng buffer
	
	while (ki != NULL)
	{
		strcpy(chiam_si, "goan-te/");
		strcat(chiam_si, ki->tong_an);
		if (stat(chiam_si, &tong_an) == -1)
		{
			// bô chit-ê tòng-àn
			sng ++;
			if ((liah_thang & KAN_TANN_LIAH_THANG) != KAN_TANN_LIAH_THANG)
			{
				i = fork();
				if (i == 0) execlp("wget", "wget", "-q", "-O", chiam_si, ki->tou, NULL);
				else ki->kiann = i;
			}
			if ((liah_thang & LIAH_TOU_KAU_OE) == LIAH_TOU_KAU_OE)
			{
				fprintf(ki_lok, "Lia̍h-sin-tô͘: wget -q -O %s %s\n", chiam_si, ki->tou );
			}
		}
		else
		{
			// ū chit-ê tòng-àn
			if (ki->kiam_cha != NULL)
			{
				strcpy(chiam_si, "md5sum goan-te/");
				strcat(chiam_si, ki->tong_an);
				thak = popen(chiam_si, "r");
				fgets(chiam_si, 1024, thak);
				if (strncmp(ki->kiam_cha, chiam_si, 32) != 0)
				{
					// kiám-cha bô-kòe, tòng-àn m̄-tio̍h
					strcpy(chiam_si, "goan-te/");
					strcat(chiam_si, ki->tong_an);
					sng++;
					if ((liah_thang & KAN_TANN_LIAH_THANG) != KAN_TANN_LIAH_THANG)
					{
						i = fork();
						if (i == 0) execlp("wget", "wget", "-q", "-O", chiam_si, ki->tou, NULL);
						else ki->kiann = i;
					}
					if ((liah_thang & LIAH_TOU_KAU_OE) == LIAH_TOU_KAU_OE)
					{
						fprintf(ki_lok, "Kiám-cha bô kòe.\n");
						fprintf(ki_lok, "Lia̍h-kū-tô͘: wget -q -O %s %s\n", chiam_si, ki->tou );
					}
				}
				else
				{
					// kiám-cha ū-kòe
					fwrite(&ki, sizeof(int), 1, sia);
					ki->liah_koe = 1;
					if ((liah_thang & LIAH_TOU_KAU_OE) == LIAH_TOU_KAU_OE)
					{
						fprintf(ki_lok, "%s kiám-cha ū kòe.\n", ki->tong_an);
					}
				}
			}
			else
			{
				// m̄-bián kiám-cha
				fwrite(&ki, sizeof(int), 1, sia);
				ki->liah_koe = 1;
				if ((liah_thang & LIAH_TOU_KAU_OE) == LIAH_TOU_KAU_OE)
				{
					fprintf(ki_lok, "%s bián kiám-cha.\n", ki->tong_an);
				}
			}
		}
				
		ki = ki->koh_1_tiunn;
	}
	
	// lâi tán wget
	ki = bat_ji_kha;
	if ((liah_thang & KAN_TANN_LIAH_THANG) != KAN_TANN_LIAH_THANG)
	{
		while (sng != 0)
		{
			kiann = wait(&i);
			if (WIFEXITED(i))
			{
				ki = bat_ji_kha;
				while (kiann != ki->kiann) 
				{
					ki = ki->koh_1_tiunn;
					if (ki == NULL) break;
				}
				if (ki != NULL)
				{
					if ((liah_thang & LIAH_TOU_KAU_OE) == LIAH_TOU_KAU_OE)
					{
						fprintf(ki_lok, "Lia̍h-tio̍h %s\n", ki->tong_an);
					}
					fwrite(&ki, sizeof(int), 1, sia);
					ki->liah_koe = 1;
					sng --;
				}
			}
		}		
	}
	else
	{
		while (ki != NULL)
		{
			if (!ki->liah_koe)
			{
					fwrite(&ki, sizeof(int), 1, sia);
					ki->liah_koe = 1;
			}
			ki = ki->koh_1_tiunn;
		}
	}
}


void senn_kha_phinn(int chui_kong, int liah_thang)
{
	struct kha_phinn *ki = bat_ji_kha;
	FILE *thak = fdopen(chui_kong, "r");
	int sng = 0;
	char chiam_si[2048];
	
	
	setbuf(thak, NULL); //bô beh ēng buffer
	
	while (ki != NULL)
	{
		sng ++;
		ki = ki->koh_1_tiunn;
	}

	while (sng != 0)
	{
		fread(&ki, sizeof(int), 1, thak);
		if (feof(thak)) break;
		
		strcpy(chiam_si, ki->tong_an);
		ki->sia = strchr(chiam_si, '.');
		if (ki->sia == NULL) ki->sia = chiam_si + strlen(ki->tong_an);
		*(ki->sia) = 0;
		strcat(chiam_si, ".jpg");
		ki->sia = strdup(chiam_si);
		
		sprintf(chiam_si, "gimp --gimprc ./gimprc -d -i -b '(script-fu-bat-ji \"goan-te/%s\" \"kha-phinn/%s\" %d %d %d %d (list %d %d %d) \"",
				ki->tong_an, ki->sia, ki->to_chhiu, ki->teng_koan, ki->chiann_chhiu-ki->to_chhiu, ki->e_kha-ki->teng_koan,
				(ki->au_piah_bin >> 16) & 0xff, (ki->au_piah_bin >> 8) & 0xff, ki->au_piah_bin & 0xff);
		if (ki->thau != 0)
		{
			strncat(chiam_si, ki->le, ki->thau);
		}
		strcat(chiam_si, "\" (list 0 0 255 ) \"");
		if (strlen(ki->le) - ki->thau - ki->boe != 0)
		{
			strncat(chiam_si, ki->le + ki->thau, strlen(ki->le) - ki->thau - ki->boe);
		}
		strcat(chiam_si, "\" (list 0 0 0 ) \"");
		if (ki->boe != 0)
		{
			strncat(chiam_si, ki->le + strlen(ki->le) - ki->boe, ki->boe);
		}
		strcat(chiam_si, "\" (list 255 0 0 ) ");
		sprintf(chiam_si, "%s \"%s\"",
				chiam_si, ki->toa_ji);
		if (ki->si_ji_bou) strcat(chiam_si, " (list 255 0 0 ) "); 
		else strcat(chiam_si, " (list 0 0 0 ) ");
		
		sprintf(chiam_si, "%s \"%s\")' -b '(gimp-quit 1)'", 
				chiam_si, ki->hoan_ho);
		
		if ((liah_thang & SENN_TOU_KAU_OE) == SENN_TOU_KAU_OE)
			fprintf(ki_lok, "Seⁿ %s: %s\n", ki->tong_an, chiam_si);

		if ((liah_thang & GIMP_KAU_OE) != GIMP_KAU_OE)
			strcat(chiam_si, " >& /dev/null");
			
		if ((liah_thang & KAN_TANN_LIAH_THANG) != KAN_TANN_LIAH_THANG)
			system(chiam_si);
		sng --;
		ki->cho_koe = 1;
	}

	ki = bat_ji_kha;
	while (ki != NULL)
	{
		if (!ki->cho_koe) fprintf(ki_lok, "%s bô chò-kòe.\n", ki->tong_an);
		ki = ki->koh_1_tiunn;
	}
}
